program Laplacian

! Take Laplacian of input file
! Input: m(iz,ix) = 2D array of size nz by nx
!  Operation:   n = 2D laplacian of 
! Output: n(iz,ix) = 2D array of size nz by nx

  use sep

implicit none

 logical    :: adj
 integer    :: ix, iz, i3, nx, nz, n3
 real       :: dz, dx, d3, oz, ox, o3
! real, dimension(:), allocatable  ::  temp
 real, dimension(:,:,:), allocatable :: model,temp

 call sep_init()


   write(0,*) ' This is Laplacian program'


  ! Read back ground model param
   call from_history("n1", nz);  call from_history("d1", dz);  call from_history("o1",oz);
   call from_history("n2", nx);  call from_history("d2", dx);  call from_history("o2",ox);
   call from_history("n3", n3,1); call from_history("o3", d3, 0.);  call from_history("o3",o3, 0.);
  
   write(0,*) '****************************'
   write(0,*) '*** Program: Laplacian.x ***'
   write(0,*) 'nz,dz,oz', nz, dz, oz
   write(0,*) 'nx,dx,ox', nx, dx, ox
   write(0,*) '****************************'


   allocate( model(nz,nx,n3), temp(nz,nx,n3))

   ! Read in the background mmocity
    call sep_read( model(1:nz,1:nx,1:n3))

   ! take the laplacian here
   ! Note, only take a 2D laplacian here, do not take a 3D laplacian
   ! simply loop over the 3rd axis (n3)
        !!!----------------------------------------------------!!!
        !!!----------------------------------------------------!!!        
        !!!                put your code here                  !!!
        !!!----------------------------------------------------!!!
        do i3= 1, n3
           do ix= 2, nx-1
              do iz= 2, nz-1
                 temp(iz,ix,i3) = -4*model(iz,ix,i3) + model(iz-1,ix,i3) + model(iz+1,ix,i3) + model(iz,ix-1,i3) + model(iz,ix+1,i3)
              end do
           end do
        end do
        !!!----------------------------------------------------!!!                


!!! Output

  call sep_write(temp,dim1=nz, dim2=nx, dim3=n3, esize=4)

  
  call to_history("n1",nz); call to_history("d1",dz);  call to_history("o1",oz);
  call to_history("n2",nx); call to_history("d2",dx);  call to_history("o2",ox);
  call to_history("n3",n3);     call to_history("d3", d3);  call to_history("o3",o3);
  
  deallocate(model, temp)

end program
