! Apply Linear interpolation operator
program Linear_interpolation

  use sep
  use clib_lint_ispc

  implicit none

  integer                           :: it,itseis,nrec,ntseis,nt,dtratio
  real                              :: dt, dtseis, oseis, orec, drec, aux
  logical                           :: adj, add
  real, dimension(:,:), allocatable :: seisinput,seisoutput

  call sep_init()

  call from_param("adj",adj,.false.)

  if(adj) then
    call from_history("n1", nrec)
    call from_history("o1", orec)
    call from_history("d1", drec)
    call from_history("n2", nt)
    call from_history("o2", oseis)
    call from_history("d2", dt)

    call from_param("dtseis",dtseis,2e-03)
    dtratio = floor(dtseis/dt)
    ntseis = ceiling((nt*dt)/dtseis)
  else
    call from_history("n1", nrec)
    call from_history("o1", orec)
    call from_history("d1", drec)
    call from_history("n2", ntseis)
    call from_history("o2", oseis)
    call from_history("d2", dtseis)

    dt = 0.4*drec/(sqrt(2.0)*3000.0) !the 0.4 is arbitrary, but it was diverging otherwise
    dtratio = ceiling(dtseis/dt)
    dt = dtseis/dtratio
    nt = 1+(float(ntseis-1)*dtseis)/dt
  endif
  aux = sqrt(float(ntseis)/float(nt))

  ! Write outputs to the terminal
  write(0,*)"============================================================="
  write(0,*)"dt=",dt
  write(0,*)"dtratio=",dtratio
  write(0,*)"nt=",nt
  write(0,*)"dtseis=",dtseis
  write(0,*)"ntseis=",ntseis
  write(0,*)"aux=",aux
  write(0,*)"============================================================="

  if(adj) then
    call to_history("n1", nrec)
    call to_history("o1", orec)
    call to_history("d1", drec)
    call to_history("n2", ntseis)
    call to_history("o2", oseis)
    call to_history("d2", dtseis)

    allocate(seisinput(nrec,nt))
    allocate(seisoutput(nrec,ntseis))
  else
    call to_history("n1", nrec)
    call to_history("o1", orec)
    call to_history("d1", drec)
    call to_history("n2", nt)
    call to_history("o2", oseis)
    call to_history("d2", dt)

    allocate(seisinput(nrec,ntseis))
    allocate(seisoutput(nrec,nt))
  endif

  seisinput = 0.
  seisoutput = 0.

  call sep_read(seisinput)

  do it=1,nt-1
    itseis  = it*(dt/dtseis)
    if(adj) call lint_serial_c(.true.,.false.,nrec,ntseis,dt,dtseis,seisoutput(:,itseis+1:itseis+2),seisinput(:,it),aux,it) 
    if(.not.adj) call lint_serial_c(.false.,.false.,nrec,ntseis,dt,dtseis,seisinput(:,itseis+1:itseis+2),seisoutput(:,it),aux,it) 
  enddo

  call sep_write(seisoutput)
  call sep_close()

end program
