module build_mod
	use sep

	implicit none
	real, allocatable :: rnd(:), jnk(:,:)
	integer           :: irnd, iold, nuse
	real              :: bigChange, angs(360), mkBig

	contains

subroutine init_build(nrnd, n)
	integer           :: n, nrnd
	
	allocate(jnk(2,n))
	bigChange = .93
	mkBig = .3

	allocate(rnd(nrnd))
	call random_number(rnd)
	irnd = 1
end subroutine


subroutine create_depth(i1, c2, c3, sz, aniso, azimuth, buf)
	integer           :: i1, ii, ns
	real              :: ex, ey, c2, c3, s, azimuth, szOld, anisoOld, aniso, sz
	real, allocatable :: buf(:,:,:)
	
	ns = min(size(buf,2), size(buf,3))

	azimuth = azimuth + (rnd(irnd)-.5)/20.
	irnd = irnd+1
	
	aniso = aniso * (1.-(rnd(irnd)-.5)/2.)
	irnd = irnd+1

	if (rnd(irnd) > bigChange) then ! Big change in cavern size
		irnd = irnd+1
		iold = 0
		bigChange = .9998
		szOld = sz
		anisoOld = aniso

		if (rnd(irnd) > mkBig) then ! Size increases
			sz = sz*10**((rnd(irnd)-.5)*3.5)
		else
			sz = 6+4*rnd(irnd)
			irnd = irnd+1
			ii = min(1,max(nuse,nint(rnd(irnd)*nuse)))
			irnd = irnd+1
		!  c2 = jnk(1,ii)
		!  c3 = jnk(2,ii)
			mkBig = .3
		end if 
	else 
		irnd = irnd+1
		sz = sz*10**((rnd(irnd)-.5)/29.)
		! irnd = irnd+1
		mkBig = mkBig*1.1;
	end if
	sz = max(3.,min(ns/6.,sz))

 ! write(0,*) "CXX",i1,ex,ey,azimuth

 ! call zero_layer(i1,c2,c3,ex,ey,azimuth,buf)
	iold=iold+1
	if(iold>20) then
		bigChange=.93
	end if
	bigChange=bigChange*.98
	c2=c2+(rnd(irnd)-.5)*4.2;irnd=irnd+1
	c3=c3+(rnd(irnd)-.5)*4.2;irnd=irnd+1;
	c2=max(3.,min(size(buf,2)*1.-3,c2))
	c3=max(3.,min(size(buf,3)*1.-3,c3))
	irnd=irnd+3; if(irnd+3>size(rnd)) irnd=0;
end subroutine

subroutine smooth(ang,nlen)
	real :: tmp(360),sm,ang(:)
	integer :: nlen,i1,i2,i
	
	tmp=ang
	do i2=1,360
		sm=0
		do i1=-nlen,nlen
			 i=i1+i2
			 if(i<1) then
				 i=360-i
			 end if
			 if(i>360) then
					i=i-360
				end if
			 sm=sm+tmp(i)
		 end do
		 ang(i2)=sm/(nlen*2+1)
	end do
end subroutine
	subroutine smooth2(array,nlen)
	real :: sm,array(:)
	integer :: nlen,i1,i2,i
	real,allocatable :: tmp(:)
	
	allocate(tmp(size(array)))
	tmp=array
	do i2=1,size(array)
		sm=0
		do i1=-nlen,nlen
			 i=max(1,min(size(array),i1+i2))
			 sm=sm+tmp(i)
		 end do
		 array(i2)=sm/(nlen*2+1)
	end do
	deallocate(tmp)
end subroutine

subroutine connectWater(buf,i1,waterDepth)
	integer :: i2,i3,i1,waterDepth(:)
	real :: buf(:,:,:)
	integer :: ia,ib,is
	integer :: ioff(2,8),id,ie
	logical :: foundAir

	ioff(:,1)=(/-1,-1/)
	ioff(:,2)=(/-1,0/)
	ioff(:,3)=(/-1,1/)
	ioff(:,4)=(/0,-1/)
	ioff(:,5)=(/0,1/)
	ioff(:,6)=(/1,-1/)
	ioff(:,7)=(/1,0/)
	ioff(:,8)=(/1,1/)
	do i3=1,size(buf,3)
		do i2=1,size(buf,2)
			if(buf(i1,i2,i3) >0.01) then
				ie=nint(buf(i1,i2,i3))
				do is=1,8
				 ia=i2+ioff(1,is)
				 ib=i3+ioff(2,is)
				 if(ia>0 .and. ia <= size(buf,2) .and. &
					 ib>0 .and. ib <= size(buf,3)) then
					 id=nint(buf(i1,ia,ib))
					 if(id >0 .and. id /= ie) then
						 if(waterDepth(id) <= i1) then
							 waterDepth(ie)=min(i1,waterDepth(ie))
						 end if
						 if(waterDepth(ie)<=i1) then
							 waterDepth(ie)=min(i1,waterDepth(id))
						 end if
						 write(0,*) "caverns connected",waterDepth(id),waterDepth(ie),id,ie
						end if
					end if
					end do
				end if
			end do
		end do
		do i3=1,size(buf,3)
			do i2=1,size(buf,2) 
				if(buf(i1,i2,i3) >0.01) then
					ie=nint(buf(i1,i2,i3))
					if(waterDepth(ie)<= i1) then
						buf(i1,i2,i3)=1490
					else
						buf(i1,i2,i3)=330.
					end if
				 end if
				end do
			end do
		 
end subroutine
subroutine zero_layer(i1,c2,c3,ex,ey,azimuth,buf,vel)
	integer :: i1,i2,i3,iang,i,ierr
	real :: ex,ey,azimuth,cs,sn,d1,d2,c2,c3,s1,s2,buf(:,:,:),angle,vel
	real :: tmp(360)
	real,allocatable :: ang(:,:)
	cs=cos(azimuth)
	sn=sin(azimuth)
	nuse=0;
	angs=rnd(irnd:irnd+359);
	irnd=irnd+360
	angs=1.-(angs-.5)*3.8
 ! allocate(ang(size(buf,2),size(buf,3)))
	do i=1,3
	call smooth(angs,6)
 end do
 !$OMP PARALLEL DO default(shared) private(i2,i3,d1,d2,s1,s2,iang) 
	do i3=1,size(buf,3)
		do i2=1,size(buf,2)
			 d1=(i2-c2)
			 d2=(i3-c3)
			 s1=cs*d1-sn*d2
			 s2=sn*d1+cs*d2
			 angle=atan2(s1,s2)
			
			 iang=angle/3.1415926536*360
			 if(iang<1) then
				 iang=iang+360
			 end if
			 if(iang>360) then
				 iang=iang-360
			 end if
			 iang=max(min(iang,360),1)
		 !  ang(i2,i3)=iang

			 if(s1*s1/ex/ex+s2*s2/ey/ey < angs(iang))then
				 buf(i1,i2,i3)=vel
			 end if
			 !irnd=irnd+1
		end do 
	end do
	!$OMP END PARALLEL DO
	!write(0,*) angs
	! ierr= srite("tmp.H",ang,size(ang)*4)
	! deallocate(ang)
	end subroutine

end module

program caverns

	use build_mod
	use sep
	implicit none

	integer :: n1,n2,n3,ii,i
	real,allocatable :: buf(:,:,:)
	real :: down,side,ex,ey
	real :: d_die
	integer,allocatable :: pts(:,:)
	integer :: nstart,iter
	integer :: iloc,ido,niter,i2,i3,i1
	real,allocatable,dimension(:) :: c2,c3,azimuth,sz,aniso
	integer :: velD
	integer,allocatable :: waterDepth(:)

	call sep_init()
	call from_param("n1",n1,300)
	call from_param("n2",n2,1000)
	call from_param("n3",n3,1000)
	! iter= sep_put_data_axis_par("out",1,n1,0.,4.,"Z(m)")
	! iter= sep_put_data_axis_par("out",2,n2,0.,4.,"X(m)")
	! iter= sep_put_data_axis_par("out",3,n3,0.,4.,"Y(m)")
	call sep_put_data_axis_par("out",1,n1,0.,4.,"Z(m)")
	call sep_put_data_axis_par("out",2,n2,0.,4.,"X(m)")
	call sep_put_data_axis_par("out",3,n3,0.,4.,"Y(m)")
	call from_param("nstart",nstart,11); 
	allocate(buf(n1,n2,n3))
	call from_param("niter",niter,199)

	call init_build(69298427,n2*n3)
	allocate(waterDepth(nstart))

	iloc=0
	buf=0.
	ii=0
	allocate(c2(n1),c3(n1),azimuth(n1),sz(n1),aniso(n1))
	do i=1,nstart
		c2(1:2) = rnd(irnd)*n2*.90+.05*n2; irnd=irnd+1
		c3(1:2) = rnd(irnd)*n3*.90+.05*n3; irnd=irnd+1
		write(0,*) "center ",c2,c3
		d_die=.999
		i1=2
		azimuth(1:2)=atan(1.)*4*rnd(irnd+1)
		sz(1:2)=6+2*rnd(irnd); irnd=irnd+1;
		aniso(1:2)=3.*(rnd(irnd)-.5)
		irnd=irnd+1
		do while(rnd(irnd) < d_die .and. i1 < n1)
			call create_depth(i1,c2(i1),c3(i1),sz(i1),aniso(i1),azimuth(i1),buf)
			d_die=d_die*.99997
			i1=i1+1
			ii=ii+1
			c2(i1)=c2(i1-1)
			c3(i1)=c3(i1-1)
			aniso(i1)=aniso(i1-1)
			azimuth(i1)=azimuth(i1-1)
			sz(i1)=sz(i1-1)
		end do
		call smooth2(c2,3)
		call smooth2(c3,3)

		call smooth2(aniso,5)
		call smooth2(azimuth,5)
		call smooth2(sz,5)
		do ido=1,i1
			ex=sz(ido);
			ey=ex*(1.-aniso(ido))
			call zero_layer(ido,c2(ido),c3(ido),ex,ey,azimuth(ido),buf,i*1.)
		end do
		
		if(irnd < size(rnd) *.8) then
			irnd=ii+i
		end if
		if(rnd(irnd)>.33) then !this cavern has water
			irnd=irnd+1
			waterDepth(i)=rnd(irnd)*n1
		else 
			waterDepth(i)=n1+1
		 end if
		 write(0,*) "CAVERN WATER LEVEL",waterDepth(i)
	end do

	do ido=1,n1
		call connectWater(buf,ido,waterDepth)
	end do

	do i=1,n3
		call srite("out",buf(:,:,i),n1*n2*4)
		! iter = srite("out",buf(:,:,i),n1*n2*4)
	end do

end program
