! Program created by Gustavo Catao Alves at
! the Stanford Exploration Project
! Feb, 3rd, 2016

! finite difference module
module clib_sinc_ispc

  use, intrinsic :: iso_c_binding

  implicit none

  interface
    subroutine sinc_serial_c(adj,add,model,dataF,filter,n1,n2,nm) bind(c,name='sinc_serial_c_')
      import
      logical(c_int),value        :: adj,add
      integer(c_int),value        :: n1,n2,nm
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
      real(c_float),dimension(*)  :: filter
    endsubroutine

    subroutine sinc2d_serial_c(adj,add,model,dataF,filter,nz,nx,nf,nm) bind(c,name='sinc2d_serial_c_')
      import
      logical(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,nf,nm
      real(c_float),dimension(*)  :: model
      real(c_float),dimension(*)  :: dataF
      real(c_float),dimension(*)  :: filter
    endsubroutine
    
    subroutine sinc_serial_double_c(adj,add,model,dataF,filter,n1,n2,nm) bind(c,name='sinc_serial_double_c_')
      import
      logical(c_int),value        :: adj,add
      integer(c_int),value        :: n1,n2,nm
      real(c_double),dimension(*)  :: model
      real(c_double),dimension(*)  :: dataF
      real(c_double),dimension(*)  :: filter
    endsubroutine

    subroutine sinc2d_serial_double_c(adj,add,model,dataF,filter,nz,nx,nf,nm) bind(c,name='sinc2d_serial_double_c_')
      import
      logical(c_int),value        :: adj,add
      integer(c_int),value        :: nz,nx,nf,nm
      real(c_double),dimension(*)  :: model
      real(c_double),dimension(*)  :: dataF
      real(c_double),dimension(*)  :: filter
    endsubroutine
  endinterface
end module
