program depth2time

	use sep
	implicit none

	integer                           :: nz, nx, nt, iz, ix, it, itarget, ntarget
	real                              :: oz, dz, ox, dx, ot, dt, z, x, t
	real, allocatable, dimension(:,:) :: mod, dat, vrms, target
	integer                           :: step
	real                              :: grad
	character(256)					  :: file_name
	integer, parameter				  :: out_unit=20

	call sep_init()

	call from_history("n1", nz)
	call from_history("o1", oz)
	call from_history("d1", dz)
	call from_history("n2", nx)
	call from_history("o2", ox)
	call from_history("d2", dx)

	call from_param("file_name", file_name)
	nt = 225
	ot = 0 
	dt = 0.004

	call to_history("n1", nt)
	call to_history("o1", ot)
	call to_history("d1", dt)
	call to_history("n2", nx)
	call to_history("o2", ox)
	call to_history("d2", dx)
	
	allocate(mod(nz,nx))
	allocate(dat(nt,nx))
	allocate(vrms(nz,nx))
	mod = 0.
	dat = 0.
	vrms = 0.

	call sep_read(mod)
	call sep_read(vrms, "vrms")

	vrms = vrms / 2.

	do it=1,nt
		do ix=1,nx
			t  = ot + it * dt
			! z  = vrms(it,ix) * t
			z = 2000. * t
			iz = (z - oz) / dz
			if ((iz >= 1) .and. (iz <= nz)) then 
				if (dat(it,ix) + mod(iz,ix) > 0) then
					dat(it,ix) = 1.
				endif
			endif 
		enddo !ix=1,nx
	enddo !iz=1,nz

	itarget = 1
	ntarget = sum(dat)

	call sep_write(dat)

	allocate(target(ntarget,2))
	target  = 0.

	do it=1,nt
		do ix=1,nx
			! if ((mod(it,2) == 0) .and. mod(ix,2) == 0) then
				if (dat(it,ix) == 1.) then
					target(itarget,1) = it
					target(itarget,2) = ix
					itarget = itarget + 1
				endif
			! endif
		enddo !ix=1,nx
	enddo !it=1,nt

	open(unit=out_unit, file=file_name, action="write", status="replace")
	do itarget=1,ntarget
		write(out_unit,*) target(itarget,1), target(itarget,2)
	enddo
	close (out_unit)

	call sep_close()

end program
