module erode_mod
  use sep
  use model_type_mod
  implicit none
  contains
  
  subroutine erode_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    character(len=256) :: tmp,v1
    call create_new_model(in,out,0,0)
    call cat_it(v1,"erode_type_",icom); call from_param(v1,tmp)
    if(tmp(1:4)=="rive") then 
      call erode_river(out,icom)
    else if(tmp(1:4)=="bowl") then
      call erode_bowl(out,icom)
    else if(tmp(1:4)=="flat") then
      call erode_flat(out,icom)
    else 
      write(0,*) "unknown erode ",trim(tmp)
    end if
  end subroutine

  
  subroutine erode_bowl(out,icom)
    type(vel_model) :: out
    integer :: icom
    integer :: i1,i2,i3
    integer :: t1,t2,t3,ierr
    integer :: b3,e3,b2,e2,ishift
    real :: center3, center2,ax1,ax2,ax3,d2,d3,d1
    real :: scale1,dist
     real :: fill_d,fill_v,p1

    character(len=128) :: tmp,v1
    real :: pi
    real :: dst2,dst3
    dst2=out%d2*out%n2
    dst3=out%d3*out%n3
    
    
    pi=atan(1.)*4;
        call cat_it(v1,"center3_",icom); call from_param(v1,center3) 
        call cat_it(v1,"center2_",icom); call from_param(v1,center2)
        call cat_it(v1,"depth_",icom); call from_param(v1,ax1)
        call cat_it(v1,"width2_",icom); call from_param(v1,ax2)
        call cat_it(v1,"width3_",icom); call from_param(v1,ax3)
      call cat_it(v1,"fill_depth_",icom); call from_param(v1,fill_d,999999.)
      call cat_it(v1,"fill_prop_",icom); call from_param(v1,fill_v,999999.)
      dst2=dst2*center2
      dst3=dst3*center3
       i2=(center2-out%o2)/out%d2+1.5
       i3=(center3-out%o3)/out%d3+1.5
       ishift=1
       do while(ishift < out%n1 .and. out%layer(ishift,i2,i3)==-1)
         ishift=ishift+1
        end do 
        
        t1=ax1/out%d1
        do i1=1,t1
          p1=out%d1*(i1-1)
          scale1=1
          d1=(out%d1*(i1-1)/ax1)**2

          do i3=max(1,ceiling((center3-out%o3-scale1*ax3)/out%d3)),min(out%n3,floor((center3-out%o3+scale1*ax3)/out%d3))
            d3=((out%o3+out%d3*(i3-1)-center3)/ax3)**2
            do i2=max(ceiling((center2-scale1*ax2-out%o2)/out%d2),1),min(floor((center2-out%o2+scale1*ax2)/out%d2),out%n2)
              d2=((out%o2+out%d2*(i2-1)-center2)/ax2)**2
              if(d2+d3+d1 <1) then
                 if(p1 > fill_d .and. out%layer(i1+ishift,i2,i3)>-1) then
                   out%layer(i1+ishift,i2,i3)=icom
                   out%vals(i1+ishift,i2,i3)=fill_v
                 else if(p1 <= fill_d) then
                   if(i1+ishift >1) then
                     if(out%layer(i1+ishift-1,i2,i3)/=-1) then
                       out%layer(:i1+ishift,i2,i3)=-1
                       out%vals(:i1+ishift,i2,i3)=-1
                     end if
                   end if
                   out%layer(i1+ishift,i2,i3)=-1
                   out%vals(i1+ishift,i2,i3)=-1
                 end if
              end if
            end do
          end do
        end do
!  out%vals=out%layer
 ! ierr=srite("layer.H",out%vals,size(out%vals)*4)
  end subroutine  

   subroutine erode_flat(out,icom)
    type(vel_model) :: out
    integer :: icom
    integer :: i1,i2,i3
    integer :: t1,t2,t3,ierr
    integer :: b3,e3,b2,e2,ishift
    real :: center3, center2,ax1,ax2,ax3,d2,d3,d1
    real :: scale1,depth
     real :: fill_d,fill_v,p1

    character(len=128) :: tmp,v1
    real :: pi

        call cat_it(v1,"depth_",icom); call from_param(v1,depth)
     i1=depth/out%d1
     out%layer(:i1,:,:)=-1
     out%vals(:i1,:,:)=-1

  end subroutine  


  subroutine erode_river(in,icom)
    type(vel_model) :: in
    real :: start2,start3
    real :: dist,angle,depth,fill_d,fill_prop,thick
    integer :: nlevels,i,n,ip,imx1,imx2,imx3,i1,i2,i3,ilevel,icom
    character(len=256) :: tmp,v1
    real :: wave(11),amp(11),gen(11)
    real :: wavelength,p,duse,d11,d22,d33
    real, allocatable :: shift(:)
    real :: xin,yin,xout,yout,cs,sn,dout2,dout3,d,waveamp
    real, allocatable:: chn(:,:,:)
    integer,allocatable :: chnl(:,:,:)
    integer :: ix,iy,ia
    
    call cat_it(v1,"start2_",icom); call from_param(v1,start2)
    call cat_it(v1,"start3_",icom); call from_param(v1,start3,0.)
    call cat_it(v1,"dist_",icom); call from_param(v1,dist,1.4)
    call cat_it(v1,"azimuth_",icom); call from_param(v1,angle)
    call cat_it(v1,"fill_depth_",icom); call from_param(v1,fill_d,0.)
    call cat_it(v1,"fill_prop_",icom); call from_param(v1,fill_prop,999999.)
    call cat_it(v1,"nlevels_",icom); call from_param(v1,nlevels,1)
    call cat_it(v1,"thick_",icom); call from_param(v1,thick)
    call cat_it(v1,"wavelength_",icom); call from_param(v1,wavelength)
        call cat_it(v1,"waveamp_",icom); call from_param(v1,waveamp)

    start2=in%o2+in%d2*start2*in%n3
    start3=in%o3+in%d3*start3*in%n3
    write(0,*) "START 3",start3
    dist=in%d3*in%n3*dist
    waveamp=waveamp*in%d3*in%n3
    wavelength=wavelength*in%d3*in%n3
    wave(2:11)=(/.7,2.4,2.8,1.5,1.8,1.2,2.1,2.4,3.8,3./)
    call random_number(gen)
    call random_number(amp)
    wave(2:11)=wave(2:11)*(1+(gen(2:11)-.5)*.18)*wavelength
    wave(1)=wavelength
    amp(1)=1.
    amp(2:11)=amp(2:11)*.24
    allocate(shift(nint(dist*1.5/min(in%d2,in%d3))))
    fill_d=thick-fill_d
    p=0
    shift=0
    write(0,*) "CHECK AMP",amp,size(shift)
    do i=1,size(shift)
       p=p+min(in%d2,in%d3)
       do ip=1,10
         shift(i)=shift(i)+amp(ip)*cos(p*atan(1.)*4/wave(ip))
    ! if(i>50 .and. i < 55) write(0,*) i,ip,shift(i),amp(ip),wave(ip),cos(p*atan(1.)*4/wave(ip))
       end do
    end do
    duse=min(in%d2,in%d3)
    cs=cos(atan(1.)/45.*angle)
    sn=sin(atan(1.)/45.*angle)
    imx1=ceiling(thick/in%d1)
    imx2=ceiling(thick/in%d2)
    imx3=ceiling(thick/in%d3)
    allocate(chn(imx1+1,imx2*2+1,imx3*2+1))
    allocate(chnl(imx1+1,imx2*2+1,imx3*2+1))
    chnl=0
    do i3=1,size(chn,3)
      d33=in%d3*(imx3+1-i3)
      do i2=1,size(chn,2)
        d22=in%d2*(imx2+1-i2)
        do i1=1,size(chn,1)
          d11=in%d1*(i1-1)
          d=sqrt(d11*d11+d22*d22+d33*d33)
          if(d<thick) then

              chn(i1,i2,i3)=fill_prop
              chnl(i1,i2,i3)=2

         end if
        end do
      end do
    end do
   shift=shift*waveamp

    do i=1,size(shift)
     do ilevel=1,nlevels
      xin=(i-1)*duse
      if(shift(i)<0.) then
        yin=shift(i)+thick*(ilevel-1)
      else 
        yin=shift(i)-thick*(ilevel-1)
      end if
      !Center of chanel
      xout=cs*xin-yin*sn+start2
      yout=sn*xin+cs*yin+start3
      ix=(xout-in%o2)/in%d2+1.5
      iy=(yout-in%o3)/in%d3+1.5
      if(ix>=imx2+1 .and. ix < in%n2-imx2-1 .and. iy >=imx3+1 .and. iy < in%n3-imx3-1) then
        do i3=1,size(chn,3)
          do i2=1,size(chn,2)
            do i1=1,size(chn,1)
              ia=i1+imx1*ilevel
              if(chnl(i1,i2,i3)>0) then
                in%vals(ia,ix-imx2-1+i2,iy-imx3-1+i3)=chn(i1,i2,i3)
             !   write(0,*) "FILLING",in%vals(ia,ix-imx2-1+i2,iy-imx3-1+i3)
                in%layer(ia,ix-imx2-1+i2,iy-imx3-1+i3)=-1
                if(chnl(ia,i2,i3)==2) in%layer(ia,ix-imx2-1+i2,iy-imx3-1+i3)=icom
              end if
            end do
          end do
        end do
      end if
     end do
    end do
      
write(0,*)"CHK",minval(in%vals),maxval(in%vals),minloc(in%vals)
     
 end subroutine
end module
    
