module fault_mod
  use model_type_mod
  use sep
  implicit none
  integer :: n_m(3),n_d
  real, pointer :: myloc(:,:)
  contains
  
  
  subroutine fault2(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom

    !parameters
    real ::xbeg,ybeg,zbeg
    real :: azimuth,dir
    real :: dz,daz
    real :: deltaTheta
    real :: perpDie,distDie,thetaDie,thetaShift
    !LOOP
    integer :: i1,i2,i3,l1,l2,l3
    real    :: p1,p2,p3,az,perp
    real    :: theta,tshift,zshift
    
    
    !CIRCLE
    real    ::ac,zc
    real    :: dist,dedge,dpt
    real :: theta1,theta2

    
    !HELPERS
    real :: pi
    real :: xshift,azshift
    real :: azbeg
    real :: naz1,naz2,nperp1,nperp2
    character(len=128) :: v1
    real  :: pratio,dratio,tratio
    real,allocatable :: shift(:,:,:,:),jnk(:,:,:)
    real :: zout,aout,xout,yout
    logical :: found
    real :: dst3,dst2,dst1
    dst2=in%d2*in%n2
    dst3=in%d3*in%n3
    dst1=in%d1*in%n1

    
     pi=atan(1.)*4;
    call cat_it(v1,"azimuth_",icom) ;call from_param(v1,azimuth)
    call cat_it(v1,"begx_",icom) ;call from_param(v1,xbeg)
    call cat_it(v1,"begy_",icom) ;call from_param(v1,ybeg)
    call cat_it(v1,"begz_",icom); call from_param(v1,zbeg)
    call cat_it(v1,"dz_",icom) ;call from_param(v1,dz)
    call cat_it(v1,"daz_",icom) ;call from_param(v1,daz)
    call cat_it(v1,"deltaTheta_",icom) ;call from_param(v1,deltaTheta)
    call cat_it(v1,"perp_die_",icom); call from_param(v1,perpDie)
    call cat_it(v1,"theta_die_",icom); call from_param(v1,thetaDie)
    call cat_it(v1,"dist_die_",icom); call from_param(v1,distDie)
    call cat_it(v1,"theta_shift_",icom); call from_param(v1,thetaShift)
    call cat_it(v1,"dir_",icom); call from_param(v1,dir)

   zbeg=dst1*zbeg
   ybeg=dst3*ybeg
   xbeg=dst2*xbeg
   distDie=distDie*dst3
   perpDie=perpDie*dst3
   

    if(dir<0.) then
      dir=-1
    else
      dir=1
    end if
    
    


    
    !Perp distance to center 
    !TRiangle construction to find out the distance to the center
    dedge=sqrt(dz*dz+daz*daz)/(2*tan(deltaTheta*pi/180./2.))
    theta=atan2(dz,daz); if(theta<0.) theta=theta+2*pi;theta=theta+pi/2
    zshift=abs(sin(theta)*dedge)
    azshift=abs(cos(theta)*dedge)

  
    write(0,*) "DISTANCE Z,X,TOT CENTER FROM FAULT ",zshift,azshift,dedge
    write(0,*) "THETA: ANGLE CENTER PT AWAY FROM BEG FAULT (0 perp fault)",theta*90./atan(1.)
    
    azshift=dz*dedge/sqrt(dz*dz+daz*daz)
    zshift=daz*dedge/sqrt(dz*dz+daz*daz)
    
    write(0,*) "SHIFT ",azshift,zshift
    zc=-zshift
    ac=dir*azshift
    if(dir>0.) then
      theta2=atan2(-zc,-ac)
      theta1=atan2(dz-zc,daz-ac)
    else
      theta1=atan2(-zc,-ac)
      theta2=atan2(dz-zc,-ac-daz)
    end if
    if(theta1<0.) theta1=theta1+pi*2
    if(theta2<0.) theta2=theta2+pi*2
    theta1=theta1*180./pi
    theta2=theta2*180/pi
    
    
    !Azimuth normal
    if(azimuth<0.) azimuth=azimuth+360.
    azimuth=azimuth*pi/180.
    naz1=cos(azimuth)
    
    naz2=-sin(azimuth)
    nperp1=sin(azimuth)
    nperp2=cos(azimuth)
    
    write(0,*) "CHECK PARMS CENTER",zc,ac
    write(0,*) "dedge",dedge
    write(0,*) "THETA",theta1,theta2
    call create_new_model(in,out,0,0)
    out%vals=-1
    allocate(shift(3,out%n1,out%n2,out%n3))
    shift=0
 !  allocate(jnk(out%n1,out%n2,out%n3))

   
   !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,az,perp,pratio,dist,tshift,theta,dratio,tratio,zout,aout,xout,yout,found)
    do i3=1,out%n3
      p3=out%o3+out%d3*(i3-1)-ybeg
      do i2=1,out%n2
        p2=out%o2+out%d2*(i2-1)-xbeg
        az=naz1*(p2)-naz2*(p3)
        perp=nperp1*(p2)+nperp2*(p3)  
        pratio=abs(perp)/perpDIe
        if(pratio<1.) then
          pratio=(1.+cos(pratio*pi))/2.
          do i1=1,out%n1
            p1=out%o1+out%d1*(i1-1)-zbeg
            dist=sqrt((p1-zc)*(p1-zc)+(az-ac)*(az-ac))
            dratio=(dedge-dist)/distDie
            theta=atan2(p1-zc,az-ac)*180./pi
            if(dratio >= 0. .and. dratio < 1. .and. p1>zc) then

              dratio=(1.+cos(dratio*pi))/2.
              theta=atan2(p1-zc,az-ac)*180./pi

              if(theta<0) theta=theta+180.
              if(theta >= theta1-thetaDie .and. theta <=theta2+thetaDie) then
                if(theta < theta1) then
                  tratio=  (theta1-theta)/thetaDie
                else if(theta<theta2) then
                  tratio=0
                else
                  tratio= (theta-theta2)/thetaDie
                end if

                tratio=(1.+cos(tratio*pi))/2. 
                tshift=thetaShift*tratio*dratio*pratio
            !    jnk(i1,i2,i3)=dist

                tshift=(theta-dir*tshift)*pi/180.
                zout=sin(tshift)*dist+zc
                aout=cos(tshift)*dist+ac
                xout=naz1*aout-naz2*perp
                yout=naz2*aout+naz1*perp
                shift(:,i1,i2,i3)=(/zout-p1,xout-p2,yout-p3/)
              end if !tratio
            end if  !dratio
          end do !p1 loop
          found=.false.
          i1=1
          do while(i1 < out%n1 .and. .not. found)
            if(shift(1,i1,i2,i3) >0.) then
              found=.true.
            else
              i1=i1+1
            end if
          end do
         if(found) shift(1,:i1,i2,i3)=shift(1,i1,i2,i3)
        end if !pratio 
      end do !p2 loop
    end do !p3 loop
    !$OMP END PARALLEL DO
   !$OMP PARALLEL DO private(i1,i2,i3,l1,l2,l3) 
    do i3=1,out%n3
      do i2=1,out%n2
        do i1=1,out%n1
          l1=min(out%n1,i1-nint(shift(1,i1,i2,i3)/out%d1))
          l2=max(1,min(in%n2,i2-nint(shift(2,i1,i2,i3)/out%d2)))
          l3=max(1,min(in%n3,i3-nint(shift(3,i1,i2,i3)/out%d3)))
          if(l1>=1) then
            out%layer(i1,i2,i3)=in%layer(l1,l2,l3)
            out%vals(i1,i2,i3)=in%vals(l1,l2,l3)
          else
             out%layer(i1,i2,i3)=-1;
             out%vals(i1,i2,i3)=0;
          end if
      !if(i3==250 .and. i2 ==500) write(0,*) "AA",i1,l1,shift(:,i1,i2,i3)
        end do
     end do
   end do
   !$OMP END PARALLEL DO
 !  write(0,*) "DIE 2",out%n1,out%n2,out%n3
! i1=srite("shift.H",jnk,size(jnk)*4)
 !deallocate(jnk)
   deallocate(shift)
  end subroutine
  subroutine fault_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    integer :: i2,i3,lshift,l1,l2,l3,ib
    integer :: imax1,imax2,imax
    real    :: cn1,cn2,cn3,co1,co2,co3,shift1,shift2,shift3,plane1,plane2,plane3
    real     :: p1,p2,p3
    real     :: shift_max,die_move,die_fault,die_perp,pp1,pp2,pp3,u1,u2,u3
    real    :: shift_up,shift_left,shift_out
    real    :: major,minor,max_shift
    real    :: t1,t2,zmax,xmax,ymax,t3,zbeg,zend,azimuth,plane4
    real    :: pl1,pl2,pl3,pdenom,dist,angle,distp,distm,distf,lens
    real    :: cs1,cs2,sn1,sn2,f,m1,m2,m3,wt_edge(41,20,20)
    real, allocatable :: shift(:,:,:,:),zax(:),jun(:,:,:)
    real :: dist1,dist2,dist3
    real major_shift,minor1_shift,minor2_shift,pi
    real :: ma1,ma2,ma3,scale
    character(len=128) :: v1
    integer :: ierr,i1,iz,ix,iy,ie,bound
    real  :: t,dl1,dl2,delta,len,scale2,dir
    real distToPlane,tUnscaled;
    
    
    pi=atan(1.)*4;
    call cat_it(v1,"plane1_",icom) ;call from_param(v1,plane1)
    call cat_it(v1,"plane2_",icom) ;call from_param(v1,plane2)
    call cat_it(v1,"plane3_",icom) ;call from_param(v1,plane3)
    call cat_it(v1,"plane_sum_",icom); call from_param(v1,plane4)
    call cat_it(v1,"old1_",icom) ;call from_param(v1,co1)
    call cat_it(v1,"old2_",icom) ;call from_param(v1,co2)
    call cat_it(v1,"old3_",icom) ;call from_param(v1,co3)
    call cat_it(v1,"new1_",icom) ;call from_param(v1,cn1)
    call cat_it(v1,"new2_",icom) ;call from_param(v1,cn2)
    call cat_it(v1,"new3_",icom) ;call from_param(v1,cn3)
    call cat_it(v1,"die_fault_",icom) ;call from_param(v1,die_fault)
    call cat_it(v1,"die_move_",icom) ;call from_param(v1,die_move)
       call cat_it(v1,"die_perp_",icom) ;call from_param(v1,die_perp)

   call cat_it(v1,"dir_",icom) ;call from_param(v1,dir)
    imax=0;imax1=0;imax2=0

    if(abs(plane1*co1+plane2*co2+plane3*co3-plane4)>2.) then
      write(0,*) "center old is not on plane"
          call create_new_model(in,out,imax,imax)
          return
      end if
    if(abs(plane1*cn1+plane2*cn2+plane3*cn3-plane4)>2.) then
      write(0,*) "center new is not on plane"
      
      end if
    if(cn1<in%o1 .or. cn1 > in%o1+in%d1*(in%n1-1))then
     write(0,*) "fault center new outside model 1"
      call create_new_model(in,out,imax,imax)
          return
      end if

    if(cn2<in%o3 .or. cn2 > in%o2+in%d2*(in%n2-1))then
     write(0,*) "fault center new outside model 2"
      call create_new_model(in,out,imax,imax)
          return
       end if

    if(cn3<in%o3 .or. cn3 > in%o3+in%d3*(in%n3-1)) then
    write(0,*) "fault center new outside model 3"
     call create_new_model(in,out,imax,imax)
          return
       end if

    if(co1<in%o1 .or. co1 > in%o1+in%d1*(in%n1-1)) then
    write(0,*) "fault center old outside model 1"
     call create_new_model(in,out,imax,imax)
          return
        end if

    if(co2<in%o2 .or. co2 > in%o2+in%d2*(in%n2-1)) then
    write(0,*) "fault center old outside model 2"
     call create_new_model(in,out,imax,imax)
          return
        end if

    if(co3<in%o3 .or. co3 > in%o3+in%d3*(in%n3-1)) then
    write(0,*) "fault center old outside model 3"
     call create_new_model(in,out,imax,imax)
          return
    end if
    m1=cn1-co1
    m2=cn2-co2
    m3=cn3-co3    
    u1=plane1/sqrt(plane1*plane1+plane2*plane2+plane3*plane3)
    u2=plane2/sqrt(plane1*plane1+plane2*plane2+plane3*plane3)
    u3=plane3/sqrt(plane1*plane1+plane2*plane2+plane3*plane3)

    
    pdenom=(plane1*plane1+plane2*plane2+plane3*plane3)
    
allocate(jun(in%n1,in%n2,in%n3))
    write(0,*) "OLD",in%n1,in%n2,in%n3,pdenom
    jun=0
    dl1=sqrt(m1*m1+m2*m2+m3*m3)
    m1=m1/dl1
    m2=m2/dl1
    m3=m3/dl1
    lens=dl1
    dl1=1
    !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,t,scale2,pl1,pl2,pl3,ma1,ma2,ma3,dl2,len,scale,imax,imax1,imax2,distToPlane,tUnscaled)
      do i3=21,in%n3-20
            p3=out%o3+out%d3*(i3-1)

      p2=in%o2+in%d2*20
      do i2=21,in%n2-20
        p1=in%o1
            !first project onto plane
         tUnscaled=-(p1*plane1+p2*plane2+p3*plane3-plane4);
         distToPlane=sqrt(tUnscaled*tUnscaled/pdenom);
         t=t/pdenom;
            if(distToPlane <die_fault) then
                  pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3) !Length away from center point
              angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1/dl2)
              !!now figure out far from the center point we are along shift direction
              len=dl2; !*cos(angle);
             len=min(.95,dl2/die_move)

              

                scale=.5*(1.+cos(len*pi))*scale2*dir
                imax1=max(nint(scale*m1/in%d1),imax1)
             end if
             p1=in%o1+(in%n1-1)*in%d1
            !first project onto plane
         tUnscaled=-(p1*plane1+p2*plane2+p3*plane3-plane4);
         distToPlane=sqrt(tUnscaled*tUnscaled/pdenom);
         t=t/pdenom;
         
            if(abs(distToPlane) <die_fault) then
                          pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3) !Length away from center point
              angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1/dl2)
              !!now figure out far from the center point we are along shift direction
              len=dl2; !*cos(angle);
             len=min(.95,dl2/die_move)

              

                scale=.5*(1.+cos(len*pi))*scale2*dir
                imax2=max(nint(scale*m1/in%d1),imax2)
             end if
        p2=p2+in%d2
      end do
    end do  
    !$OMP END PARALLEL DO
    imax=max(imax1,imax2)
    write(0,*) "IMAX",imax1,imax2,imax

    call create_new_model(in,out,imax,imax)
    allocate(shift(3,out%n1,out%n2,out%n3))
    shift=0
    write(0,*) "XXXX",plane1,plane2,plane3
   !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,t,distp,distm,distf,scale2,ma1,ma2,ma3,dl2,len,scale,tUnscaled,distToPlane,pp1,pp2,pp3,angle,pl1,pl2,pl3)
    do i3=21,out%n3-20
      p3=out%o3+out%d3*(i3-1)
      p2=out%o2+out%d2*20
      do i2=21,out%n2-20
        p1=out%o1
        do i1=imax+1,out%n1-imax
            !first project onto plane
         tUnscaled=-(p1*plane1+p2*plane2+p3*plane3-plane4);
         distToPlane=sqrt(tUnscaled*tUnscaled/pdenom);
         t=tUnscaled/pdenom;
           
            if(distToPlane <die_fault) then
              scale2=(1.+cos(distToPlane/die_fault*pi))/2.

              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3) !Length away from center point
              ma1=ma1/dl2
              ma2=ma2/dl2
              ma3=ma3/dl2
              dl2=1
              !unit vector perp to movement and fault plane
              pp1=u2*m3-u3*m2
              pp2=u1*m3-u3*m1
              pp3=u1*m2-u2*m1
              !Distance between fault center and current point
              pl1=p1-co1
              pl2=p2-co2
              pl3=p3-co3
              !Distances in rotated coordinate system
              distp=pp1*pl1+pp2*pl2+pp3*pl3
              distf=u1*pl1+u2*pl2+u3*pl3
              distm=m1*pl1+m2*pl2+m3*pl3

              
             
               if(i3==401 .and. i1 >10 .and. i1 < 20 .and. i2 >300 .and. i2 <320) then
                  write(0,*) i1,i2,distm,distf,distp,distToPlane
                end if
              distm=distm/die_move
              distp=distp/die_perp
              if(abs(distm)< 1 .and. abs(distp)<1) then
                scale=(1+cos(distm*pi))/2.*scale2*(1.+cos(distp*pi))/2.;
               
               jun(i1,i2,i3)=scale*m1*lens

              !  shift(:,i1,i2,i3)=scale*(/m1,m2,m3/)*lens
                if(p1*plane1+p2*plane2+p3*plane3-plane4>0) shift(:,i1,i2,i3)=-scale*(/m1,m2,m3/)*lens
   
              end if
             end if
             p1=p1+out%d1
         end do
        p2=p2+out%d2
      end do
    end do  
    !$OMP END PARALLEL DO

    !handle the simple edges
    !$OMP PARALLEL DO private(i1,i2,i3,scale)
    do i3=1,20
      scale=1.-(1.+cos(real(i3-1)/20.*pi))/2.
      do i2=21,out%n2-20
        do i1=1,out%n1
          shift(:,i1,i2,i3)=scale*shift(:,i1,i2,21)
          shift(:,i1,i2,out%n3-i3+1)=scale*shift(:,i1,i2,out%n3-20)
          
        end do
      end do
    end do
    !$OMP END PARALLEL DO

   !$OMP PARALLEL DO private(scale,i1,i2,i3)
    do i3=21,out%n3-20
      do i2=1,20
      scale=1.-(1.+cos(real(i2-1)/20.*pi))/2.
        do i1=1,out%n1
          shift(:,i1,i2,i3)=scale*shift(:,i1,21,i3)
          shift(:,i1,out%n2-i2+1,i3)=scale*shift(:,i1,out%n2-20,i3)
        end do
     end do
   end do
   !$OMP END PARALLEL DO

    do i3=1,20
      do i2=1,20
         if(i2/=1 .or. i3/=1) then
           do ib=1,20
             wt_edge(ib,i2,i3)=(i2-ib)*(i2-ib)+(i3-21)*(i3-21)
             wt_edge(ib+20,i2,i3)=(i2-21)*(i2-21)+(i3-ib)*(i3-ib)
           end do
           wt_edge(41,i2,i3)=(i2-1)*(i2-1)+(i3-1)*(i3-1)
           wt_edge(:,i2,i3)=1./wt_edge(:,i2,i3)
           scale=sum(wt_edge(:,i2,i3))
           wt_edge(:,i2,i3)=wt_edge(:,i2,i3)/scale
         else
           wt_edge(1:40,1,1)=0
           wt_edge(41,1,1)=1.
         end if
      end do
    end do
  !$OMP PARALLEL DO private(scale,i1,i2,i3)
   do i3=1,20
     do i2=1,20
       do i1=1,out%n1
         do ib=1,20
           shift(:,i1,i2,i3)=shift(:,i1,i2,i3)+wt_edge(ib,i2,i3)*shift(:,i1,i2,21)+shift(:,i1,21,i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,out%n2+1-i2,i3)=shift(:,i1,out%n2+1-i2,i3)+&
              wt_edge(ib,i2,i3)*shift(:,i1,out%n2+1-i2,21)+shift(:,i1,out%n2-20,i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,i2,out%n3+1-i3)=shift(:,i1,i2,out%n3+1-i3)+&
             wt_edge(ib,i2,i3)*shift(:,i1,i2,out%n3-20)+shift(:,i1,21,out%n3+1-i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,out%n2+1-i2,out%n3+1-i3)=shift(:,i1,out%n2+1-i2,out%n3+1-i3)+&
             wt_edge(ib,i2,i3)*shift(:,i1,out%n2+1-i2,out%n3-20)+shift(:,i1,out%n2-20,out%n3+1-i3)*wt_edge(ib+21,i2,i3)
        end do
     !   write(0,*) "CHECK SHIFT",shift(:,200,i2,i3),i2,i3
      end do
    end do
  end do  
  !$OMP END PARALLEL DO
   !APPLY THE SHIFT
   
   jun=0
    !$OMP PARALLEL DO private(i1,i2,i3,l1,l2,l3) 
    do i3=1,out%n3
      do i2=1,out%n2
        do i1=1,out%n1
          l1=max(1,min(out%n1,imax1+i1-nint(shift(1,i1,i2,i3)/out%d1)))
          jun(i1,i2,i3)=l1-i1

          l2=max(1,min(in%n2,i2-nint(shift(2,i1,i2,i3)/out%d2)))
          l3=max(1,min(in%n3,i3-nint(shift(3,i1,i2,i3)/out%d3)))
          out%layer(i1,i2,i3)=in%layer(l1,l2,l3)
          out%vals(i1,i2,i3)=in%vals(l1,l2,l3)
          if(i1>18 .and. i1 < 23 .and. i2 >270 .and. i2 < 275 .and. i3==401) then
          end if
        end do
     end do
   end do
   !$OMP END PARALLEL DO
   
   //   i1=srite("scale.H",jun,size(jun)*4)
deallocate(jun)
    deallocate(shift)
  end subroutine







end module