! Linear interpolation operator module
module lint_mod

  implicit none
  integer, private                      :: nm1, nd1
  real, private                         :: o1, d1
  real, dimension(:), pointer, private  :: coordinate 

  contains

  subroutine lint_init(nm1_in, nd1_in, o1_in, d1_in, coordinate_in)
    integer                     :: nm1_in, nd1_in
    real                        :: o1_in, d1_in
    real, dimension(:), target  :: coordinate_in
    nm1 = nm1_in
    nd1 = nd1_in
    o1 = o1_in
    d1 = d1_in
    coordinate => coordinate_in
  end subroutine

  function lint_op(adj, add, model, data) result(stat)
    logical,intent(in)          :: adj, add
    real,dimension(:)           :: model,data
    integer                     :: stat

    call lint_op2(adj,add,model,data)
    stat=0    
  end function

  subroutine lint_op2(adj,add,model,data)
    logical                     :: adj, add
    integer                     :: i,j,x,xm
    real                        :: temp, alfa
    real,dimension(nm1)         :: model
    real,dimension(nd1)         :: data

  if (adj) then
    if (.not. add) model=0
  else
    if (.not. add) data=0
  end if
  
  if (adj) then
    do i=1,nd1
      temp = (1.0*coordinate(i)-o1)/d1
      x = temp
      xm = x+1
      alfa = temp - 1.0*x
      if (xm.ge.1 .and. xm.lt.nm1) then
        model(xm) = model(xm) + (1.0-alfa)*data(i)
        model(xm+1) = model(xm+1) + (alfa)*data(i)
      endif
    end do
  else
    do i=1,nd1
      temp = (1.0*coordinate(i)-o1)/d1
      x = temp
      xm= x+1
      alfa = temp - 1.0*x
      if (xm.ge.1 .and. xm.lt.nm1) then
        data(i) = data(i) + (1.0-alfa)*model(xm)+alfa*model(xm+1)
      endif
    end do
  endif

  end subroutine

  subroutine lint_op3(model)
    integer                     :: i
    real,dimension(nm1)         :: model

    

    do i=1,nm1
      if(model(i)==0.0) model(i)=1.0
    enddo    

  end subroutine

end module
