program scatter

	use sep
	implicit none

	integer                             :: nz, nx, ny, iz, ix, iy, i, nd
	real                                :: oz, dz, ox, dx, oy, dy, z, x, y
	real, allocatable, dimension(:,:,:) :: mod
	real, allocatable, dimension(:,:)   :: dat

	call sep_init()

	call from_history("n1", nz)
	call from_history("o1", oz)
	call from_history("d1", dz)
	call from_history("n2", nx)
	call from_history("o2", ox)
	call from_history("d2", dx)
	call from_history("n3", ny)
	call from_history("o3", oy)
	call from_history("d3", dy)
	
	allocate(mod(nz,nx,ny))
	mod = 0.
	call sep_read(mod)
	nd = sum(mod)

	call to_history("n1", nd)
	call to_history("o1", 0)
	call to_history("d1", 1)
	call to_history("n2", 3)
	call to_history("o2", 0)
	call to_history("d2", 1)

	allocate(dat(nd,3))
	dat = 0.

	i = 1
	do iz=1,nz
		do ix=1,nx
			do iy=1,ny
				if (mod(iz,ix,iy) ==1) then
					z = oz + iz * dz
					x = ox + ix * dx
					y = oy + iy * dy
					dat(i,1) = x
					dat(i,2) = y 
					dat(i,3) = z
					i = i + 1
				endif
			enddo 
		enddo !ix=1,nx
	enddo !iz=1,nz

	call sep_write(dat)

	call sep_close()

end program
