module squish_mod
  use model_type_mod
  use sep
  implicit none
  
  contains
  
  
  
  subroutine squish_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    real    :: center2,center3,d2,p3,p2,f2,f3,sh
    integer :: i2,i3,iz,i1,ia,ib,ibeg,iend
    integer :: imax_shift,ishift,nn,ix
    character(len=128) :: v1,v2
    real  ::major,minor,basement,cs,sn
    real   :: rotate,maxshift,wavelength,rand_in,rand_cross,d,dd
    real, allocatable :: shift(:,:),dist(:,:),bb(:,:),ss(:,:,:),top(:,:),bot(:,:)
    real :: rands(10,2)
    real :: wv(10)
    
    
    call cat_it(v1,"azimuth_",icom) ;call from_param(v1,rotate)
    call cat_it(v1,"max_",icom) ;call from_param(v1,maxshift)
    call cat_it(v1,"wavelength_",icom) ;call from_param(v1,wavelength)
    call cat_it(v1,"random_inline_",icom) ;call from_param(v1,rand_in)
    call cat_it(v1,"random_crossline_",icom) ;call from_param(v1,rand_cross)

    wavelength=wavelength*in%d2*in%n2
    nn=max(in%n1,in%n2)*3;
   allocate(shift(nn,nn))
   imax_shift=maxshift/in%d1 
   call create_new_model(in,out,imax_shift,imax_shift)
  wv=(/1.2,5.,1.9,2.4,3.8,1.4,4.2,3.1,3.4,2.0/)
  wv=wavelength*wv
   d=0
   do i2=1,nn
     d=d+in%d2
     shift(i2,:)=cos(d/wavelength*atan(1.)*4.)
   end do

   call random_number(rands)
   rands=rands-.5
   rands=rands*2.
  ! rands=rands/3.
   !Now add some randomness
   do i1=1,10
     d2=0
     do i3=1,nn
       dd=cos(d2/wv(i1)*atan(1.)*4.)*rands(i1,2)*rand_cross
       d2=d2+in%d3
       d=0
       do i2=1,nn
         shift(i2,i3)=shift(i2,i3)+dd+cos(d/wv(i1)*atan(1.)*4.)*rands(i1,1)*rand_in
             !     shift(i2,i3)=dd+cos(d/wv(i1)*atan(1.)*4.)*rands(i1,1)*rand_in
!
         d=d+in%d2
       end do
    end do
  end do
  shift=shift*maxshift/maxval(abs(shift))
  
  allocate(bb(nn,nn),dist(nn,nn))
  do i3=1,nn
    d=0
    do i2=1,nn-1
      d=d+in%d2/cos(atan((shift(i2+1,i3)-shift(i2,i3))/in%d2))
      bb(i2,i3)=d
    end do
    d=d+in%d2/cos(atan((shift(nn,i3)-shift(nn-1,i3))/in%d2))
    bb(i2,i3)=d
  end do
  center2=nn/2*in%d2

  do i3=1,nn
    d2=bb(nn/2,i3)
    d=0
    do i2=1,nn
      d=d+in%d2
      dist(i2,i3)=bb(i2,i3)-d2+(center2-d)
    end do
  end do
  

  cs=cos(rotate*atan(1.)/45.)
  sn=sin(rotate*atan(1.)/45.)
  allocate(ss(3,out%n2,out%n3))
  do i3=1,out%n3
    p3=(i3-out%n3/2)*out%d3
    do i2=1,out%n2
      p2=(i2-out%n2/2)*out%d2
      d=cs*p2-sn*p3
      d2=sn*p2+cs*p3
      f2=d/out%d2+nn/2
      f3=d2/out%d2+nn/2
      ia=f2
      ib=f3
      f2=f2-ia
      f3=f3-ib
      ss(1,i2,i3)=(1.-f2)*(1.-f3)*shift(ia,ib)+(1.-f2)*f3*shift(ia,ib+1)+&
          f2*(1.-f3)*shift(ia+1,ib)+f2*f3*shift(ia+1,ib+1)
      sh=(1.-f2)*(1.-f3)*dist(ia,ib)+(1.-f2)*f3*dist(ia,ib+1)+&
          f2*(1.-f3)*dist(ia+1,ib)+f2*f3*dist(ia+1,ib+1)
     bb(i2,i3)=sh
      ss(2:3,i2,i3)=sh*(/cs,sn/)


    end do
  end do
  deallocate(bb,dist,shift)

  allocate(top(in%n2,in%n3),bot(in%n2,in%n3))
  call random_number(top)
  call random_number(bot)
  top=top-.5
  bot=bot-.5

  call smooth_2d(top,(/25,25/),3)
  call smooth_2d(bot,(/25,25/),3)

  top=top/maxval(abs(top))
  bot=bot/maxval(abs(bot))


  top=top*.45+.55
  bot=bot*.45+.55
 !top=1
 !bot=1
!  top=1
!  bot=.1
  
 ! top=top-bot
  do i3=1,in%n3
      do i2=1,in%n2
        ib=min(max(i3+nint(ss(3,i2,i3)/in%d3),1),in%n3)
        ia=min(max(i2+nint(ss(2,i2,i3)/in%d2),1),in%n2)
        i1=ss(1,i2,i3)/in%d1
        ibeg=imax_shift+i1
        out%layer(1:ibeg,i2,i3)=-1  ; out%vals(1:ibeg,i2,i3)=-1;
        do i1=1,in%n1
          f2=real(i1-1)/real(in%n1)
          f3=top(i2,i3)*(1.-f2)+f2*bot(i2,i3)
          f3=f3*ss(1,i2,i3)
          ix=i1-nint(f3/in%d1)
          if(ix<1) then
            out%layer(ibeg+i1,i2,i3)=-1
            out%vals(ibeg+i1,i2,i3)=-1
          else
            ix=min(ix,in%n1)
            out%layer(ibeg+i1,i2,i3)=in%layer(ix,ia,ib); 
            out%vals(ibeg+i1,i2,i3)=in%vals(ix,ia,ib)
          end if
        end do
        out%layer(ibeg+in%n1+1:,i2,i3)=0; out%vals(ibeg+in%n1+1:,i2,i3)=in%vals(in%n1,ia,ib)
      end do
    end do
  deallocate(ss)
  end subroutine

subroutine smooth_2d(field,nlen,ntms)
 real :: field(:,:)
 real, allocatable :: t1(:,:),t2(:,:)
 integer :: n1,n2,nlen(2),ntms
 integer :: i1,i2,itm,nsz(2)
 real ::bsum
 
 n1=size(field,1)
 n2=size(field,2)
 nsz=(/n1+nlen(1)*2,n2+nlen(2)*2/)
 allocate(t1(n1+nlen(1)*2,n2+nlen(2)*2),t2(n1+nlen(1)*2,n2+2*nlen(2)))
 t1=0
 t1(nlen(1)+1:nlen(1)+n1,nlen(2)+1:nlen(2)+n2)=field


  do itm=1,ntms!{
  !$OMP PARALLEL DO PRIVATE(i2,i1,bsum)
      do i2=1,nsz(2)!{
        bsum=sum(t1(1:nlen(1)*2+1,i2))
        t2(1:nlen(1)+1,i2)=bsum/(nlen(1)*2+1)
        do i1=nlen(1)+2,nsz(1)-nlen(1)-1!{
          bsum=bsum-t1(i1-nlen(1)-1,i2)+t1(i1+nlen(1),i2)
          t2(i1,i2)=bsum/(nlen(1)*2+1)
        end do!}
        t2(nsz(1)-nlen(1):,i2)=0
        bsum=sum(t2(nsz(1)-nlen(1)*2:,i2))
       
        t1(nsz(1)-nlen(1),i2)=bsum/(nlen(1)*2+1)
        do i1=nsz(1)-nlen(1)-1,nlen(1)+1,-1!{
          bsum=bsum-t2(i1+nlen(1)+1,i2)+t2(i1-nlen(1),i2)
          
          t1(i1,i2)=bsum/(nlen(1)*2+1)
        end do!}
        t1(1:nlen(1),i2)=t2(1:nlen(1),i2)
        
     end do!}
     !$OMP END PARALLEL DO
     

  !   write(0,*) "AXIS 1 done"
  !$OMP PARALLEL DO private(i1,i2,bsum)
     do i1=1,nsz(1)!{
       bsum=sum(t1(i1,1:nlen(2)*2+1))
         
       t2(i1,1:nlen(2)+1)=bsum/(nlen(2)*2+1)
       do i2=nlen(2)+2,nsz(2)-nlen(2)-1!{
       
         bsum=bsum-t1(i1,i2-nlen(2)-1)+t1(i1,i2+nlen(2))
         
         t2(i1,i2)=bsum/(nlen(2)*2+1)
       end do!}
      
       t2(i1,nsz(2)-nlen(2):)=0
       bsum=sum(t2(i1,nsz(2)-nlen(2)*2:))
       t1(i1,nsz(2)-nlen(2))=bsum/(nlen(2)*2+1)

      

       do i2=nsz(2)-nlen(2)-1,nlen(2)+1,-1 !{
         bsum=bsum-t2(i1,i2+nlen(2)+1)+t2(i1,i2-nlen(2))
         t1(i1,i2)=bsum/(nlen(2)*2+1)
       end do !}
       t1(i1,1:nlen(2))=t2(i1,1:nlen(2))
  
     end do !}
     !$OMP END PARALLEL DO
  end do
  !i1=srite("t.H",t1,size(t1)*4)
  call srite("t.H",t1,size(t1)*4)
  write(0,*) "CHECK",nsz
   field=t1(nlen(1)+1:nlen(1)+n1,nlen(2)+1:nlen(2)+n2)
  deallocate(t1,t2)
end subroutine
  
end module
          
    
