program target

	use sep
	implicit none

	integer                           :: nz, nx, iz, ix, itarget, ntarget
	real                              :: oz, dz, ox, dx, z, x
	real, allocatable, dimension(:,:) :: mod, target
	character(256)					  :: file_name
	integer, parameter				  :: out_unit=20

	call sep_init()

	call from_history("n1", nz)
	call from_history("o1", oz)
	call from_history("d1", dz)
	call from_history("n2", nx)
	call from_history("o2", ox)
	call from_history("d2", dx)
	call from_param("file_name", file_name)

	allocate(mod(nz,nx))
	mod = 0.
	call sep_read(mod)
	itarget = 1
	ntarget = sum(mod)

	allocate(target(ntarget,2))
	target  = 0.

	do iz=1,nz
		do ix=1,nx
			if (mod(iz,ix) == 1.) then
				target(itarget,1) = iz * 5 
				target(itarget,2) = ix * 5
				itarget = itarget + 1
			endif
		enddo !ix=1,nx
	enddo !it=1,nt

	open(unit=out_unit, file=file_name, action="write", status="replace")
	do itarget=1,ntarget
		write(out_unit,*) target(itarget,1), target(itarget,2)
	enddo
	close (out_unit)
end program
