! Main program to add a maks to the top of the model so that model(smooth) = model(true) at source
program top_mask

  use sep

  implicit none

  integer                               :: nz,nx,iz,ix,layer,trans
  real                                  :: dz,oz,dx,ox
  real                                  :: aux,alfa
  real, allocatable, dimension(:,:)     :: modelin,modelref,modelout

  call sep_init()

  ! Model parameters
  ! Dimensions
  call from_history("n1",nz)                    !# of samples in depth
  call from_history("o1",oz,0.0)                !origin for depth coord
  call from_history("d1",dz)                    !grid spacing in depth
  call from_history("n2",nx)                    !# of samples in x
  call from_history("o2",ox,0.0)                !origin for x coord
  call from_history("d2",dx)                    !grid spacing in x

  call from_param("layer",layer,0)              !number os samples of mask
  call from_param("transition",trans,20)        !smooth pass to model

  allocate(modelin(nz,nx))
  allocate(modelref(nz,nx))
  allocate(modelout(nz,nx))

  call sep_read(modelin)
  call sep_read(modelref,"modelref")

  alfa=0.01

  modelout = modelin
  modelout(1:layer,:) = modelref(1:layer,:)
  do iz=1,trans
    aux=(1.0*(iz-trans))
    modelout(layer+iz,:)= modelref(layer+1,:) + exp(-alfa*aux*aux)*(modelout(layer+iz,:)-modelref(layer+1,:))
  enddo


  ! Write SEP header parameter
  call to_history("n1",nz)
  call to_history("o1",oz)
  call to_history("d1",dz)
  call to_history("n2",nx)
  call to_history("o2",ox)
  call to_history("d2",dx)
  call to_history("label1","z")
  call to_history("label2","x")

  call sep_write(modelout)

  call sep_close

end program
