module uplift_mod
  use model_type_mod
  use sep
  implicit none
  
  contains
  
  
  subroutine uplift_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    real    :: center2,center3
    integer :: i2,i3,iz,i1
    integer :: imax_shift,ishift
    integer, allocatable :: zilch(:,:)
    real    :: dist,dist2,dist3,len_major,len_minor,shift,loc,pi,rotate,sn,cs
    character(len=128) :: v1,v2
    real  ::major,minor,basement
        real :: dst3,dst2,dst1
    dst2=in%d2*in%n2
    dst3=in%d3*in%n3
    dst1=in%d1*in%n1
    dst1=1;dst2=1; dst3=1;
    pi=atan(1.)*4;
    call cat_it(v1,"center2_",icom) ;call from_param(v1,center2)
    call cat_it(v1,"center3_",icom) ;call from_param(v1,center3)
    call cat_it(v1,"die_major_",icom) ;call from_param(v1,len_major)
    call cat_it(v1,"die_minor_",icom) ;call from_param(v1,len_minor)
    call cat_it(v1,"shift_",icom) ;call from_param(v1,shift)
    call cat_it(v1,"azimuth_",icom) ;call from_param(v1,rotate)
    center2=center2*dst2
    center3=center3*dst3
    len_major=center2*dst2
    len_minor=center3*dst3
    cs=cos(rotate/180.*pi)
    sn=sin(rotate/180.*pi)
    allocate(zilch(in%n2,in%n3))
    call find_nolayer(in,zilch)
    imax_shift=0;
    do i3=1,in%n3
      dist3=(center3-(in%o3+in%d3*(i3-1)))
      do i2=1,in%n2
        dist2=(center2-(in%o2+in%d2*(i2-1)))
                major=(cs*dist3-sn*dist2)/len_major
                        minor=(sn*dist3+cs*dist2)/len_minor

        dist=sqrt(major*major+minor*minor)

        if(dist < 1.) then
          loc=shift/2+(shift/2.*(cos(dist*pi)))

     !     if(nint(loc/in%d1)>0) write(0,*) "DDD",nint(loc/in%d1),zilch(i2,i3),imax_shift
          if(nint(loc/in%d1)-zilch(i2,i3)>imax_shift) imax_shift=nint(loc/in%d1)-zilch(i2,i3);
        end if
      end do
    end do
write(0,*) "IMAX SHICFT",imax_shift

  !  if(imax_shift==0) call seperr("max shift is 0")
    call create_new_model(in,out,imax_shift,0)
    zilch=zilch+imax_shift
    basement=get_basement()
    
    do i3=1,in%n3
      dist3=(center3-(in%o3+in%d3*(i3-1)))
      do i2=1,in%n2
        dist2=(center2-(in%o2+in%d2*(i2-1)))
        major=(cs*dist3-sn*dist2)/len_major
        minor=(sn*dist3+cs*dist2)/len_minor
        dist=sqrt(major*major+minor*minor)
        if(dist < 1.) then
          loc=shift/2+(shift/2.*(cos(dist*pi)))
          ishift=nint(loc/in%d1)
          if(ishift>0) then
            iz=zilch(i2,i3)
            do i1=1,in%n1-ishift
               out%layer(i1,i2,i3)=out%layer(i1+ishift,i2,i3)
               out%vals(i1,i2,i3)=out%vals(i1+ishift,i2,i3)
            end do
            if(in%n1-ishift+2 <= in%n1) then
              out%vals(in%n1-ishift+1:,i2,i3)=basement
              out%layer(in%n1-ishift+1:,i2,i3)=0
            end if
     !   out%layer(1+(imax_shift-ishift):(imax_shift-ishift)+in%n1,i2,i3)=in%layer(1:in%n1,i2,i3) 
       !   out%vals(1+(imax_shift-ishift):(imax_shift-ishift)+in%n1,i2,i3)=in%vals(1:in%n1,i2,i3)
          end if


        end if
      end do
    end do

        deallocate(zilch)

  !  call fix_basement(out);   
  end subroutine
  
  
end module
          
    
